/*============================================================================
 File Name:	   mdidemo.prg
 Author:       Marcus Herz
 Description:
 Created:			 20.02.2020     15:20:29        Updated: 20.02.2020      15:20:29
 Copyright:		 2020 DS-Datasoft, 87671 Ronsberg
 Revision:
 $Group:
============================================================================*/


#include "common.ch"
#include "std.ch"
#include "Xbp.ch"
#include "os.ch"
#include "AppEvent.ch"
#include "dsListLabel.ch"

STATIC nThreadCnt
STATIC lPrint := TRUE					// FALSE erzeugt PDFs
STATIC cPrinter


PROCEDURE Main
	LOCAL oThread, oPrinter
	LOCAL i, nSleep
   LOCAL lThread	:= FALSE			// kann auf TRUE gesetzt werden fr untere Schleife mit Threads
   										// aber threads sind fr Speicherfehler nicht relevant

   oPrinter	:= xbpPrinter():New():create()
   cPrinter	:= oPrinter:setdefault():drivername
   oPrinter:destroy()

   nThreadCnt	:= 0

   // 1xig LL laden fr speicher kontrolle
   Print()

	?
   ? "memory(MEM_VIRT_AVAIL)", "memory(MEM_RAM_AVAIL)", "memory(MEM_HANDLES_USED)"
   ? memory(MEM_VIRT_AVAIL), memory(MEM_RAM_AVAIL), memory(MEM_HANDLES_USED)
   ? "bereit, Taste Drcken zum Starten"
   inkey(0)


	for i := 1 to 40
   	if lThread
			nSleep := randomint(10, 300)
    		sleep(nSleep)
	      nThreadCnt++
	      ? "Starte Thread, Durchlauf:", i, "Anz Threads", nThreadCnt, memory(MEM_HANDLES_USED)
			oThread	:= Thread():New()
	      oThread:start({|| Print()})
      else
      	sleep(10)
  	      ? "Starte Durchlauf:", i, memory(MEM_HANDLES_USED)
	      Print()
      endif
	next
   sleep(100)
   ?
	? memory(MEM_HANDLES_USED)
   ? "fertig, Taste Drcken"
   inkey(0)

RETURN


/*
 * Example for AppSys() in an MDI application
 * This function is executed prior to Main()
 */
PROCEDURE DbeSys
	IF ! DbeLoad( "FOXDBE", .T.)      // load engine for DBF files
      ALERT( "Database Engine FOXDBE not loaded" , {"OK"} )
   ENDIF

   IF ! DbeLoad( "CDXDBE" , .T.)     // load engine for CDX files
      ALERT( "Database Engine CDXDBE not loaded" , {"OK"} )
   ENDIF
                                     // assemble engines for data
                                     // record and index management
   IF ! DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
      ALERT( "Database Engine FOXCDX not created" , {"OK"} )
   ENDIF
RETURN


//=========================================
FUNC Print()
	LOCAL oListLabel
	LOCAL cFile
	LOCAL cPath	:= GetEnv("TEMP")
	LOCAL i

	// D: Datenbank sollte bei Applikation liegen...
	// US: Database should be with application exe...
	USE ARTICLE INDEX ARTICLE NEW SHARED
	GOTO TOP

	// DEMO CODE starts here
	// D: Klasse initialisieren
	// US:class init
	oListLabel	:= dsListLabel():New(SetAppWindow())

	// D: aktuelle Workarea anmelden, ber dies Tabelle wird fr die Liste geskippt
	// US:register active workarea, the report will skip through this table
	oListLabel:connect()

	// D: alle Felder der aktuellen Workarea fr LLDefineField anmelden
	// US:register all columns of active workarea for LLDefineField
	oListLabel:DataSetField()


	// D: Extra Feld definieren fr LLDefineField, wird nach jedem Skip ausgefhrt
	// US:define extra field for LLDefineField, executed after each skip
	oListLabel:defineField("ARTICLENO_EAN128", {|o,n| (n)->ARTICLENO}, LL_BARCODE_EAN128 )

	// D: Dateiauswahldialog oeffnen
	// US: Call file open dialog
	oListLabel:report	:= "article.lst"
   oListLabel:Printer(cPrinter)

		// D:  automatisiertes Erstellen eines PDF ohne Benutzeraingriff: SaveAsPdf(cFile, lQuiet)
		// US: automated creation of a PDF file without user interaction: SaveAsPdf(cFile, lQuiet)
   if lPrint
	      oListLabel:Print()
  	else
      for i := randomint(4, 10) to 1 step -1
			cFile	:= cPath + "\PDF"+ strzero(seconds()*100,8) + strzero(i,2.0)+".PDF"
			oListLabel:saveaspdf(cFile, TRUE )
  		next
	endif
	// D: aufrumen
	// E: clean up
	oListLabel:destroy()

	dbCloseArea()
   nThreadCnt--

RETURN NIL
